/*
 * Block.h
 *
 *  Created on: 14.12.2015
 *      Author: Helge
 */

#ifndef BLOCK_H_
#define BLOCK_H_

#include "Utility.h"
#include <string>
#include <map>

class BlockIndex;
class BloomFilter;

class Block {
public:
	Block() {
	}
	Block(intSet in_X, intSet in_Y, intSet in_Z) {
		X = in_X;
		Y = in_Y;
		Z = in_Z;
	}
	intSet X;
	intSet Y;
	intSet Z;
};

struct BlockCLusterResult {
	intSet* removedIds;
	intVector openCluster;
};

class BlockIndex {
private:
	int counter;
	int id;
	std::map<int,intSet> xindex;
	std::map<int,intSet> yindex;
	std::map<int,intSet> zindex;
public:
	intSet blockIds;
	std::vector<Block*> coords;

	BlockIndex();
	BlockIndex(int _id);
	~BlockIndex();
	std::vector<Block*> getBlocks();
	void addBlock(intSet X, intSet Y, intSet Z);
	void addBlockSingleton(int x, int y, int z);
	void mergeBlocks(int leftblock, int rightblock);
	void mergeXYZ(int leftblock, intSet X, intSet Y, intSet Z);
	void toFile(std::string fileName);
	bool update(std::vector<coordinate>* coords,BloomFilter* bfMask);
	bool update(std::vector<coordinate>* coords, intVector* candidates, BloomFilter* bfMask);
};

#endif /* BLOCK_H_ */
