/*
 * Global.cpp
 *
 *  Created on: 01.01.2016
 *      Author: Helge
 */

#include "Global.h"
#include "omp.h"
#include "Utility.h"
#include <math.h>
#include <limits>
#include <stdio.h>

// Global Variables
std::vector<coordinate> global::coordinates;
BloomFilter* global::BF = NULL;
BloomFilter* global::BFmask = NULL;
FiberGraph* global::Graph = NULL;

// Settings
std::string global::CONFIG_FILE = "config.txt";
std::string global::INPUT_FILE = INPUT_FILE_DEFAULT;
std::string global::OUTPUT_FILE = OUTPUT_FILE_DEFAULT;
std::string global::REPORT_FILE = REPORT_FILE_DEFAULT;

//Parameters
int global::BLOCK_MINSIZE = BLOCK_MINSIZE_DEFAULT;
int global::BLOCK_MINVOL = BLOCK_MINVOL_DEFAULT;
float global::BLOCK_THRESHOLD = BLOCK_THRESHOLD_DEFAULT;
long global::BLOOM_CAPACITY = BLOOM_CAPACITY_DEFAULT;
float global::BLOOM_ERROR_RATE = BLOOM_ERROR_RATE_DEFAULT;
int global::EXPAND_NUM_SEEDS = EXPAND_NUM_SEEDS_DEFAULT;
int global::SPLIT_MIN_DIAM = SPLIT_MIN_DIM_DEFAULT;

int global::MAX_X;
int global::MAX_Y;
int global::MAX_Z;
int global::SIZE_TENSOR;

void global::reset() {

	global::BF = NULL;
	global::BFmask = NULL;
	global::Graph = NULL;

	// Settings
	global::INPUT_FILE = INPUT_FILE_DEFAULT;
	global::OUTPUT_FILE = OUTPUT_FILE_DEFAULT;
	global::REPORT_FILE = REPORT_FILE_DEFAULT;

	// Parameters
	global::BLOCK_MINSIZE = BLOCK_MINSIZE_DEFAULT;
	global::BLOCK_MINVOL = BLOCK_MINVOL_DEFAULT;
	global::BLOCK_THRESHOLD = BLOCK_THRESHOLD_DEFAULT;
	global::BLOOM_CAPACITY = BLOOM_CAPACITY_DEFAULT;
	global::BLOOM_ERROR_RATE = BLOOM_ERROR_RATE_DEFAULT;
	global::EXPAND_NUM_SEEDS = EXPAND_NUM_SEEDS_DEFAULT;
	global::SPLIT_MIN_DIAM = SPLIT_MIN_DIM_DEFAULT;

	//Proprties
	global::MAX_X = 0;
	global::MAX_Y = 0;
	global::MAX_Z = 0;
	global::SIZE_TENSOR = 0;
}

std::string global::allToString() {
	std::string result;
	result += "------------------------------------------------------------\n";
	result += "File Settings: \n";
	result += "INPUT FILE         = " + toString(global::INPUT_FILE) + "\n";
	result += "OUTPUT FILE        = " + toString(global::OUTPUT_FILE) + "\n";
	result += "REPORT FILE        = " + toString(global::REPORT_FILE) + "\n";
	result += "------------------------------------------------------------\n";
	result += "Parameters: \n";
	result += "BLOCK MINSIZE      = " + toString(global::BLOCK_MINSIZE) + "\n";
	result += "BLOCK MINVOLUME    = " + toString(global::BLOCK_MINVOL) + "\n";
	result += "BLOCK DENSITY      = " + toString(global::BLOCK_THRESHOLD) + "\n\n";
	result += "BLOOM CAPACITY     = " + toString(global::BLOOM_CAPACITY) + "\n";
	result += "BLOCK ERROR RATE   = " + toString(global::BLOOM_ERROR_RATE) + "\n\n";
	result += "EXPAND NUM SEEDS   = " + toString(global::EXPAND_NUM_SEEDS) + "\n";
	result += "SPLIT MIN DIAMETER = " + toString(global::SPLIT_MIN_DIAM) + "\n";
	result += "------------------------------------------------------------\n";
	return result;
}
